/*
 * Examples.java
 * Created on 25.04.2003
 */
package search.graph;

/**
 * Zwei Beispielgraphen.
 * @author Erich Ehses.
 */
public final class Examples {
    static final int TYP_VERBINDUNG = 0;


    private Examples() {
    }
    
    /**
     * Erzeugt einen Graphen fuer einige deutsche Staedte und ihre
     * Strassenverbindungen.
     * 
     * @return Graph fuer das Verkehrsnetz.
     */
    public static Graph germany() {
        /*
         * Die Argumente zu addNode beziehen sich auf Breite und Laenge der
         * Orte (ungefaehr).
         */
        Graph g = new Graph();
        //addNode(g, "Flensburg",54.75,9.5);
        addNode(g, "Kiel",54.3,10.2);
        addNode(g, "Lbeck",53.9,10.75);
        addNode(g, "Hamburg",53.6,10);
        addNode(g, "Bremen",53.1,8.8);
        addNode(g, "Bremerhaven",53.6,8.6);
        //addNode(g, "Wilhelmshaven",53.6,8.1);
        addNode(g, "Oldenburg",53.2,8.2);
        addNode(g, "Osnabrck",52.3,8.1);
        addNode(g, "Hannover",52.4,9.7);
        addNode(g, "Braunschweig",52.3,10.5);
        addNode(g, "Gttingen",51.5,9.9);
        addNode(g, "Kassel",51.3,9.5);
        addNode(g, "Bielefeld",52,8.5);
        addNode(g, "Mnster",51.9,7.6);
        addNode(g, "Duisburg",51.4,6.7);
        addNode(g, "Essen",51.4,7.1);
        addNode(g, "Dortmund",51.5,7.5);
        addNode(g, "Wuppertal",51.3,7.2);
        addNode(g, "Dsseldorf",51.2,6.8);
        addNode(g, "Mnchengladbach",51.3,6.4);
        addNode(g, "Kln",50.9,6.9);
        addNode(g, "Bonn",50.7,7.1);
        addNode(g, "Koblenz",50.4,7.6);
        addNode(g, "Aachen",50.8,6.1);
        addNode(g, "Trier",49.75,6.6);
        addNode(g, "Saarbrcken",49.2,7);
        addNode(g, "Wiesbaden",50.1,8.2);
        addNode(g, "Mainz",50,8.2);
        addNode(g, "Kaiserslautern",49.4,7.75);
        addNode(g, "Mannheim",49.5,8.5);
        addNode(g, "Heidelberg",49.4,8.7);
        addNode(g, "Karlsruhe",49,8.4);
        addNode(g, "Pforzheim",48.9,8.7);
        addNode(g, "Stuttgart",48.8,9.2);
        addNode(g, "Freiburg",48,7.8);
        addNode(g, "Lrrach",47.6,7.6);
        addNode(g, "Villach",48,8.5);
        addNode(g, "Singen",47.75,8.8);
        addNode(g, "Lindau",47.5,9.7);
        addNode(g, "Ulm",48.4,10);
        addNode(g, "Kempten",47.7,10.3);
        addNode(g, "Augsburg",48.4,10.8);
        addNode(g, "Mnchen",48.2,11.6);
        addNode(g, "Passau",48.6,13.5);
        addNode(g, "Regensburg",49,12.1);
        addNode(g, "Nrnberg",49.4,11.1);
        addNode(g, "Erlangen",49.6,11);
        addNode(g, "Bayreuth",49.9,11.6);
        addNode(g, "Bamberg",49.9,10.9);
        addNode(g, "Wrzburg",49.8,9.9);
        addNode(g, "Heilbronn",49.2,9.2);
        addNode(g, "Darmstadt",49.8,8.6);
        addNode(g, "Frankfurt",50.1,8.6);
        addNode(g, "Schweinfurt",50,10.2);
        addNode(g, "Siegen",50.9,8);
        addNode(g, "Giessen",50.6,8.7);
        addNode(g, "Paderborn",51.2,8.7);
        //addNode(g, "Rosenheim",47.8,12.2);
        addNode(g, "Tbingen",48.5,9.1);
        addNode(g, "Ingolstadt",48.75,11.4);
        addNode(g, "Berlin",52.5,13.5);
        addNode(g, "Frankfurt/Oder",52.3,14.5);
        addNode(g, "Cottbus",51.75,14.3);
        addNode(g, "Chemnitz",50.8,12.9);
        addNode(g, "Brandenburg",52.4,12.5);
        addNode(g, "Magdeburg",52.1,11.6);
        addNode(g, "Halle",51.5,12);
        addNode(g, "Erfurt",51,11);
        addNode(g, "Gera",50.8,12.1);
        addNode(g, "Leipzig",51.3,12.4);
        addNode(g, "Dresden",51.1,13.75);
        addNode(g, "Grlitz",51.2,15);
        addNode(g, "Schwerin",53.6,11.4);
        addNode(g, "Rostock",54.1,12.1);
        addNode(g, "Stralsund",54.3,13.1);
        addNode(g, "Greifswald",54.1,13.4);
        addNode(g, "Neubrandenburg",53.6,13.25);
        //g.addEdge("Flensburg","Kiel",TYP_VERBINDUNG);
        g.addEdge("Kiel","Lbeck",TYP_VERBINDUNG);
        g.addEdge("Kiel","Hamburg",TYP_VERBINDUNG);
        g.addEdge("Lbeck","Hamburg",TYP_VERBINDUNG);
        g.addEdge("Hamburg","Bremen",TYP_VERBINDUNG);
        g.addEdge("Hamburg","Bremerhaven",TYP_VERBINDUNG);
        g.addEdge("Hamburg","Hannover",TYP_VERBINDUNG);
        g.addEdge("Hamburg","Braunschweig",TYP_VERBINDUNG);
        g.addEdge("Bremen","Bremerhaven",TYP_VERBINDUNG);
        g.addEdge("Bremen","Oldenburg",TYP_VERBINDUNG);
        g.addEdge("Bremen","Hannover",TYP_VERBINDUNG);
        g.addEdge("Bremen","Osnabrck",TYP_VERBINDUNG);
        //g.addEdge("Oldenburg","Wilhelmshaven",TYP_VERBINDUNG);
        g.addEdge("Oldenburg","Osnabrck",TYP_VERBINDUNG);
        g.addEdge("Hannover","Osnabrck",TYP_VERBINDUNG);
        g.addEdge("Hannover","Braunschweig",TYP_VERBINDUNG);
        g.addEdge("Hannover","Gttingen",TYP_VERBINDUNG);
        g.addEdge("Hannover","Paderborn",TYP_VERBINDUNG);
        g.addEdge("Hannover","Bielefeld",TYP_VERBINDUNG);
        g.addEdge("Braunschweig","Gttingen",TYP_VERBINDUNG);
        g.addEdge("Gttingen","Kassel",TYP_VERBINDUNG);
        g.addEdge("Osnabrck","Bielefeld",TYP_VERBINDUNG);
        g.addEdge("Osnabrck","Mnster",TYP_VERBINDUNG);
        g.addEdge("Bielefeld","Paderborn",TYP_VERBINDUNG);
        g.addEdge("Bielefeld","Dortmund",TYP_VERBINDUNG);
        g.addEdge("Mnster","Dortmund",TYP_VERBINDUNG);
        g.addEdge("Mnster","Essen",TYP_VERBINDUNG);
        g.addEdge("Paderborn","Kassel",TYP_VERBINDUNG);
        g.addEdge("Paderborn","Dortmund",TYP_VERBINDUNG);
        g.addEdge("Dortmund","Wuppertal",TYP_VERBINDUNG);
        g.addEdge("Dortmund","Siegen",TYP_VERBINDUNG);
        g.addEdge("Essen","Duisburg",TYP_VERBINDUNG);
        g.addEdge("Duisburg","Dsseldorf",TYP_VERBINDUNG);
        g.addEdge("Duisburg","Mnchengladbach",TYP_VERBINDUNG);
        g.addEdge("Dsseldorf","Mnchengladbach",TYP_VERBINDUNG);
        g.addEdge("Dsseldorf","Kln",TYP_VERBINDUNG);
        g.addEdge("Dsseldorf","Wuppertal",TYP_VERBINDUNG);
        g.addEdge("Mnchengladbach","Aachen",TYP_VERBINDUNG);
        g.addEdge("Mnchengladbach","Kln",TYP_VERBINDUNG);
        g.addEdge("Aachen","Kln",TYP_VERBINDUNG);
        g.addEdge("Wuppertal","Essen",TYP_VERBINDUNG);
        g.addEdge("Wuppertal","Kln",TYP_VERBINDUNG);
        g.addEdge("Kassel","Giessen",TYP_VERBINDUNG);
        g.addEdge("Siegen","Giessen",TYP_VERBINDUNG);
        g.addEdge("Giessen","Frankfurt",TYP_VERBINDUNG);
        g.addEdge("Giessen","Koblenz",TYP_VERBINDUNG);
        g.addEdge("Kln","Trier",TYP_VERBINDUNG);
        g.addEdge("Kln","Bonn",TYP_VERBINDUNG);
        g.addEdge("Bonn","Koblenz",TYP_VERBINDUNG);
        g.addEdge("Koblenz","Trier",TYP_VERBINDUNG);
        g.addEdge("Koblenz","Mainz",TYP_VERBINDUNG);
        g.addEdge("Trier","Saarbrcken",TYP_VERBINDUNG);
        g.addEdge("Trier","Kaiserslautern",TYP_VERBINDUNG);
        g.addEdge("Trier","Mainz",TYP_VERBINDUNG);
        g.addEdge("Saarbrcken","Kaiserslautern",TYP_VERBINDUNG);
        g.addEdge("Saarbrcken","Karlsruhe",TYP_VERBINDUNG);
        g.addEdge("Kaiserslautern","Mannheim",TYP_VERBINDUNG);
        g.addEdge("Mainz","Wiesbaden",TYP_VERBINDUNG);
        g.addEdge("Mainz","Mannheim",TYP_VERBINDUNG);
        g.addEdge("Wiesbaden","Frankfurt",TYP_VERBINDUNG);
        g.addEdge("Wiesbaden","Darmstadt",TYP_VERBINDUNG);
        g.addEdge("Frankfurt","Darmstadt",TYP_VERBINDUNG);
        g.addEdge("Frankfurt","Wrzburg",TYP_VERBINDUNG);
        g.addEdge("Darmstadt","Mannheim",TYP_VERBINDUNG);
        g.addEdge("Mannheim","Heidelberg",TYP_VERBINDUNG);
        g.addEdge("Heidelberg","Karlsruhe",TYP_VERBINDUNG);
        g.addEdge("Heidelberg","Heilbronn",TYP_VERBINDUNG);
        g.addEdge("Wrzburg","Heilbronn",TYP_VERBINDUNG);
        g.addEdge("Wrzburg","Erlangen",TYP_VERBINDUNG);
        g.addEdge("Wrzburg","Schweinfurt",TYP_VERBINDUNG);
        g.addEdge("Wrzburg","Bamberg",TYP_VERBINDUNG);
        g.addEdge("Bamberg","Bayreuth",TYP_VERBINDUNG);
        g.addEdge("Bamberg","Erlangen",TYP_VERBINDUNG);
        g.addEdge("Bayreuth","Erlangen",TYP_VERBINDUNG);
        g.addEdge("Heilbronn","Nrnberg",TYP_VERBINDUNG);
        g.addEdge("Heilbronn","Stuttgart",TYP_VERBINDUNG);
        g.addEdge("Karlsruhe","Pforzheim",TYP_VERBINDUNG);
        g.addEdge("Karlsruhe","Freiburg",TYP_VERBINDUNG);
        g.addEdge("Pforzheim","Stuttgart",TYP_VERBINDUNG);
        g.addEdge("Stuttgart","Tbingen",TYP_VERBINDUNG);
        g.addEdge("Stuttgart","Ulm",TYP_VERBINDUNG);
        g.addEdge("Tbingen","Villach",TYP_VERBINDUNG);
        g.addEdge("Freiburg","Lrrach",TYP_VERBINDUNG);
        g.addEdge("Freiburg","Villach",TYP_VERBINDUNG);
        g.addEdge("Lrrach","Singen",TYP_VERBINDUNG);
        g.addEdge("Singen","Villach",TYP_VERBINDUNG);
        g.addEdge("Singen","Lindau",TYP_VERBINDUNG);
        g.addEdge("Lindau","Kempten",TYP_VERBINDUNG);
        g.addEdge("Lindau","Ulm",TYP_VERBINDUNG);
        g.addEdge("Ulm","Augsburg",TYP_VERBINDUNG);
        g.addEdge("Augsburg","Nrnberg",TYP_VERBINDUNG);
        g.addEdge("Augsburg","Mnchen",TYP_VERBINDUNG);
        g.addEdge("Nrnberg","Erlangen",TYP_VERBINDUNG);
        g.addEdge("Nrnberg","Ingolstadt",TYP_VERBINDUNG);
        g.addEdge("Nrnberg","Regensburg",TYP_VERBINDUNG);
        g.addEdge("Ingolstadt","Regensburg",TYP_VERBINDUNG);
        g.addEdge("Ingolstadt","Mnchen",TYP_VERBINDUNG);
        g.addEdge("Regensburg","Passau",TYP_VERBINDUNG);
        g.addEdge("Mnchen","Passau",TYP_VERBINDUNG);
        //g.addEdge("Mnchen","Rosenheim",TYP_VERBINDUNG);
        g.addEdge("Mnchen","Kempten",TYP_VERBINDUNG);
        g.addEdge("Kempten","Ulm",TYP_VERBINDUNG);
        g.addEdge("Kempten","Augsburg",TYP_VERBINDUNG);
        g.addEdge("Dortmund","Essen",TYP_VERBINDUNG);
        g.addEdge("Berlin","Brandenburg",TYP_VERBINDUNG);
        g.addEdge("Berlin","Frankfurt/Oder",TYP_VERBINDUNG);
        g.addEdge("Berlin","Halle",TYP_VERBINDUNG);
        g.addEdge("Berlin","Cottbus",TYP_VERBINDUNG);
        g.addEdge("Berlin","Dresden",TYP_VERBINDUNG);
        g.addEdge("Berlin","Schwerin",TYP_VERBINDUNG);
        g.addEdge("Berlin","Rostock",TYP_VERBINDUNG);
        g.addEdge("Berlin","Neubrandenburg",TYP_VERBINDUNG);
        g.addEdge("Schwerin","Hamburg",TYP_VERBINDUNG);
        g.addEdge("Schwerin","Lbeck",TYP_VERBINDUNG);
        g.addEdge("Schwerin","Rostock",TYP_VERBINDUNG);
        g.addEdge("Rostock","Stralsund",TYP_VERBINDUNG);
        g.addEdge("Stralsund","Greifswald",TYP_VERBINDUNG);
        g.addEdge("Neubrandenburg","Greifswald",TYP_VERBINDUNG);
        g.addEdge("Frankfurt/Oder","Cottbus",TYP_VERBINDUNG);
        g.addEdge("Dresden","Cottbus",TYP_VERBINDUNG);
        g.addEdge("Dresden","Chemnitz",TYP_VERBINDUNG);
        g.addEdge("Dresden","Grlitz",TYP_VERBINDUNG);
        g.addEdge("Dresden","Leipzig",TYP_VERBINDUNG);
        g.addEdge("Grlitz","Cottbus",TYP_VERBINDUNG);
        g.addEdge("Chemnitz","Leipzig",TYP_VERBINDUNG);
        g.addEdge("Chemnitz","Gera",TYP_VERBINDUNG);
        g.addEdge("Gera","Leipzig",TYP_VERBINDUNG);
        g.addEdge("Gera","Erfurt",TYP_VERBINDUNG);
        g.addEdge("Leipzig","Halle",TYP_VERBINDUNG);
        g.addEdge("Halle","Magdeburg",TYP_VERBINDUNG);
        g.addEdge("Brandenburg","Magdeburg",TYP_VERBINDUNG);
        g.addEdge("Erfurt","Kassel",TYP_VERBINDUNG);
        g.addEdge("Chemnitz","Bayreuth",TYP_VERBINDUNG);
        g.addEdge("Magdeburg","Braunschweig",TYP_VERBINDUNG);
        g.addEdge("Erfurt","Halle",TYP_VERBINDUNG);
        g.addEdge("Erfurt","Giessen",TYP_VERBINDUNG);
        g.addEdge("Erfurt","Schweinfurt",TYP_VERBINDUNG);
        return g;
    }
    
    /**
     * Erzeugt einen ganz einfachen Testgraphen.
     * @return Testgraph.
     */
    public static Graph test() {
        Graph g = new Graph();
        g.addNode("A", 0,0);
        g.addNode("B", 1,0);
        g.addNode("C", 1,1);
        g.addNode("D", 0,1);
        g.addNode("E", 0.5, 0.5);
        g.addNode("F", 1, 0.9);
        g.addEdge("A", "B",0);
        g.addEdge("B", "F",0);
        g.addEdge("F", "C",0);
        g.addEdge("C", "D",0);
        g.addEdge("D", "A",0);
        g.addEdge("E", "F",0);
        g.addEdge("A", "E",0);
        return g;
    }
    
    /**
     * Wandle die geographische Information in ein Kilometernetz um
     * und trage den Knoten im Graphen ein.
     * Diese Methode funktioniert nur fuer Deutschland.
     * @param g Graph in den der Knoten eingetragen wird.
     * @param name Knotenname.
     * @param latitude geographische Breite des Ortes.
     * @param longitude geographische Laenge des Ortes.
     */
    private static void addNode(Graph g, String name, 
        double latitude, double longitude)
    {
        g.addNode(name, longitude*71.0, latitude*111.0);    
    }
    
}
