/*
 * Main.java
 * Created on 22.04.2003
 */

package search.gui;

import search.graph.Examples;
import search.graph.Graph;
import search.graph.ObservableSolver;
//import search.graph.KFZ;

import java.awt.BorderLayout;

import javax.swing.JFrame;

/**
 * Main-Klasse fuer Suchalgorithmen mit graphischer Oberflaeche.
 * @author Erich Ehses.
 */
public final class Main extends JFrame {
    
    /**
     * Erzeugt das Startfenster.
     * @param solver Loesungsverfahren.
     * @param graph Graph in dem gesucht wird.
     */
    public Main(ObservableSolver solver, Graph graph) {
        super("Demonstration von ant-net");
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        getContentPane().setLayout(new BorderLayout());
        
        DataPanel data = new DataPanel(solver, graph);
        solver.addObserver(data);
        getContentPane().add(data, BorderLayout.WEST);
        
        Roadmap map = new Roadmap(graph, 500, 600);
        solver.addObserver(map);
        getContentPane().add(map, BorderLayout.EAST);
        
        pack();
        setResizable(false);
        setVisible(true);
    }
    
    /**
     * main-Methode.
     * @param args keine.
     */
    public static void main(String[] args) {
        // erzeuge den Graphen:
        Graph g = Examples.germany();

        // erzeuge das Sucher-Objekt:
        ObservableSolver s = new ObservableSolver();
        // erzeuge die GUI
        new Main(s, g);
        // starte die Anwendungsmethode.
        s.run();
    } 
}
