package search.util;

import search.graph.Node;

/**
 * Ein Eintrag in RoutingTable
 */
public class RoutingTableEntry {


    // der eventuell zu whlende Nachbarknoten
    private Node neighbourNode;

    // ...falls man auf dem Weg zu diesem Zielknoten ist
    private Node goalNode;

    // die Gte, die bisher fr diese Verbindung ermittelt wurde (Pheromone)
    private int pheromoneValue;

    // die Strecke, die diese Verbindung bis zum Zielknoten bentigt
    private double pathlength;

    // die Netzlast, die im Moment auf dieser Verbindung besteht
    private int traffic;

    public RoutingTableEntry(Node neighbourNode, Node goalNode, int pheromoneValue, double pathLength) {
        this.neighbourNode = neighbourNode;
        this.goalNode = goalNode;
        this.pheromoneValue = pheromoneValue;
        this.pathlength = pathLength;
    }

    public double getPathlength() {
        return pathlength;
    }

    public void setPathlength(double pathlength) {
        this.pathlength = pathlength;
    }

    public Node getNeighbourNode() {
        return neighbourNode;
    }

    public void setNeighbourNode(Node neighbourNode) {
        this.neighbourNode = neighbourNode;
    }

    public Node getGoalNode() {
        return goalNode;
    }

    public void setGoalNode(Node goalNode) {
        this.goalNode = goalNode;
    }

    public int getPheromoneValue() {
        return pheromoneValue;
    }

    public void setPheromoneValue(int pheromoneValue) {
        this.pheromoneValue = pheromoneValue;
    }

    public int getTraffic() {
        return traffic;
    }

    public void setTraffic(int traffic) {
        this.traffic = traffic;
    }
}
